;FR NICHT INVERTIERTEN EINGANG

;NICHT QUARZ-ZEIT JUSTIERT

;ES SCHALTET BEI EIN ALS LOW
;SIEHE AUF ZEILE: (MAN KANN AUCH SUCHEN MIT "SCHALT")
;1397
;1528
;1638
;2581
;2713

;1X SCHALTEN IST NUR EINGETRAGEN / ES STEHT GANZ AM SCHLUSS

;ES GEHT MIT BIS ZU 200X SCHALTEN EINTRAGEN / SIEHE BEI SCHALTUHREN

;****************************************************************************************
;*                           DCF77-FUNK-SCHALT-UHR MIT ANZEIGE VON DL3UKH               *
;*                           ============================================               *
;*                                                                                      *
;****************************************************************************************

    LIST    P=16F648A    
    TITLE   "DCF-77 FUNK-SCHALT-UHR"

    INCLUDE <P16F648A.INC>
__CONFIG   _HS_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _CP_OFF

    ERRORLEVEL -302

;ALS PIC-IC WURDE GENOMMEN PIC16F648A

;DER QUARZ HAT 16,0000 MHZ ALSO T=0.0625S  T==TAKTZEIT 
    
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;HIER KANN MAN AENDERN:
;EIN SEMIKOLON DAVOR BEWIRKT DAS DER "BEFEHL" ALS KOMMENTAR GILT. 
;
;                 
;DIE IMPULS-LAENGEN-GRENZEN BEI DCF77-FUNKUHREN-BETRIEB:
;    
;MINIMALE ZAHL D'1' /// MAXIMALE ZAHL D'255'
;    
;HIER UNTERHALB IN MSEC 
;FUER LANGEN "HIGH" IMPULS EXAKT WAEREN ES 200MSEC
;JETZT IN DEN GRENZEN VON 150MSEC BIS 240MSEC DECODIERBAR / SONST FEHLERMELDUNG ALS KOMMA    
IMPULS_HIGH_DOWN        EQU D'150'
IMPULS_HIGH_UP          EQU D'240'    
;    
;HIER UNTERHALB IN MSEC
;FUER KURZEN "LOW" IMPULS EXAKT WAEREN ES 100MSEC
;JETZT IN DEN GRENZEN VON 50MSEC BIS 160MSEC DECODIERBAR / SONST FEHLERMELDUNG ALS KOMMA    
IMPULS_LOW_DOWN         EQU D'50'
IMPULS_LOW_UP           EQU D'140'    
;
;        
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------

;REGISTER ZUORDNEN NACHFOLGEND DER FESTEN REGISTERN

W_STACK EQU  0X22       ;FR PUSH+POP
S_STACK EQU  0X23       ;FR PUSH+POP
HELP0   EQU  0X24       ;500MS-ZHLER //BEI 15SEC-PAUSE UND 1SEC-QUARZ-TAKT
MERK    EQU  0X25       ;BIT6=BEI MIN/H NICHTBEREINSTIMMUNG DOCH ZULASSUNG
                    ;     BEI 1.-TEM START
                    ;BIT7=MERKER BEI DCF-ZEITBERNAHME KURZ BLINKEN
                    ;     VON 00SEC NACH 01SEC
                    ;BIT0=ZEITUMSTELLUNGBIT DER 16-SEC
                    ;BIT1=MERKER FR ZEITUMSTELLUNG

Z_LL    EQU  0X26       ;ZHLER-LOW-(LOW=BYTE)
Z_LH    EQU  0X27       ;ZHLER-LOW-(HIGH=BYTE)
Z_H     EQU  0X28       ;ZHLER-HIGH-(ZEIT)
Z_IMP   EQU  0X29       ;ZHLER SEC-IMPULSE
DCF_DA  EQU  0X2A       ;BIT0 ==> 1=DCF IST DA, 0=DCF IST NICHT DA

OK      EQU  0X2B       ;BIT0=MIN-PARITT BIT1=H-PARITT BIT2=RAHMEN><
PAR     EQU  0X2C       ;PARITT IM AUSLESEPROZESS
ZUST    EQU  0X2D       ;ZUSTAND =1


SEC     EQU  0X2E       ;ANZEIGE-ZEIT UND QARZ-ZEIT
MIN     EQU  0X2F
H       EQU  0X30

I_MIN   EQU  0X31       ;IMPULS AUSGELESENE ZEIT
I_H     EQU  0X32

MIN_V   EQU  0X33       ;ZUR +1 VERGLEICHSBERECHNUNG
H_V     EQU  0X34

MIN_1   EQU  0X35       ;ANFANGSVERGLEICH ODER BEI ZEITUMSTELLUNG
H_1     EQU  0X36       ;ZWEI ZEITEN MESSEN ZUR SICHERHEIT



SZ      EQU  0X37       ;SOMMERZEIT MIT HIGH WINTERZEIT LOW BIT18 SZ-BIT0 GENUTZT
WOC     EQU  0X38       ;WOCHENTAG AUSWERTER 1=MON 7=SON BIT42-44
KALT    EQU  0X39       ;KALENDERTAG WIE 31.
MONA    EQU  0X3A       ;MONAT
JAR     EQU  0X3B       ;JAHR

;==================================================
HELP1   EQU  0X3C       ;HILFSZELLE
HELP2   EQU  0X3D       ;HILFSZELLE
X4      EQU  0X3E       ;MS1 * 4 WEGEN QUARZ
;==================================================


ZAE     EQU  0X3F       ;ZAEHLER FR SCHALTEN ALSO TABELLE MIT ZAEHLER DURCHSUCHEN
MERA    EQU  0X40       ;MERKER FR TABELLE AUSLESEN
MERB    EQU  0X41       ;BIT0 -ZULASSUNG ZUM SCHALTEN DCF77-SIGNAL MUSS EINMAL RICHTIG DECODIERT SEIN, LED AN RA5 MUSS KURZ AUFBLITZEN
                    ;BIT7 -BEI 1-HIGH IST EINGESCHALTET -BEI 0-LOW IST AUSGESCHALTET, FUER DIE RICHTIGE TABELLEN ABFRAGE OB BEI EIN ODER AUS
MERC    EQU  0X42       ;MERKER BEI TABELLENVERGLEICH 00SEC

MERKE   EQU  0X43
BIT     EQU  0X44
HELP3   EQU  0X45       

;S_WOC   EQU  0X46       ;WOCHE SICHERN FR SCHALTEN 





;VARIABLEN
BIT7    EQU 7       ; BIT 7
BIT6    EQU 6       ; BIT 6
BIT5    EQU 5       ; BIT 5
BIT4    EQU 4       ; BIT 4
BIT3    EQU 3       ; BIT 3 
BIT2    EQU 2       ; BIT 2
BIT1    EQU 1       ; BIT 1 
BIT0    EQU 0       ; BIT 0

SCHALT  EQU 1       ;PORTA BIT1

;==================================================
RS      EQU 2       ; PORTA BIT2 UMSCHALTEN BEFEHL/DATEN      BEI WRITE DATEN IST ES HIGH
EN      EQU 3       ; PORTA BIT3 ENABLE FALLENDE FLANKE
;==================================================

;MAN KANN HIER DIE PIEPS-UHRZEIT NDERN
;ZEIT FR PIEPS ZUR VOLLEN STUNDE IN DER 00SEC
STELL_AB_HIER   EQU 0X07    ;ALSO JETZT AB 7UHR    // KLEINSTE UHRZEIT IST 0X00 / ALSO NULL UHR
STELL_BIS_HIER  EQU 0X22    ;ALSO JETZT BIS 22UHR  // GRSSTE UHRZEIT IST 0X23  / ALSO 23UHR
;ALSO
;MIT 0X00 BIS 0X23 PIEPST ES JEDE STUNDE 


;------------ MACROS ---------------------------------------------------------

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM
;----------------------------------------------------------------------------

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM
;----------------------------------------------------------------------------

MS1     MACRO               ; FR EINE MILLISEKUNDE
        BCF INTCON, T0IF    ;TIMER0 KEIN INTERRUPT + OVERFLOW = 0
        BCF INTCON, T0IE    ;KEIN INTERRUPT
        MOVLW   0X06        ;1MS/16=6.25MYS/0.25MYS=250TAKTE
        MOVWF   TMR0        ;0X100(256)-0XFA(250)=0X06(6)  +OHNE(JUSTAGE)
        BSF STATUS, RP0     ;BANK1
        MOVLW   B'00000001' ;PRESCALE1:4 / SYSTEMCLOCK T/4 ==>1/16
        MOVWF   OPTION_REG  ;TEILER 1:4 + CYCLUS CLOCK
        BCF STATUS, RP0     ;BANK0
        ENDM
;----------------------------------------------------------------------------



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ALTES PROGRAMMTEIL MIT ZEITEN
; ACHTUNG HIER KOMMEN DIE IMPULS-BEREICHE REIN
; IN DIESEN BEREICHEN WERDEN DIE LNGEN ZU LOW UND HIGH

AUSW    MACRO
;        MOVLW   D'50'       ;60
;        SUBWF   Z_H, W
;        BTFSS   STATUS, C   ;GRER ALS 60MS SONST FEHLERPUNKT
;        GOTO    VOR1
;        MOVLW   D'140'      ;AUCH SCHREIBBAR ALS H'8C'
;        SUBWF   Z_H, W
;        BTFSC   STATUS, C   ;KLEINER ALS 140MS SONST FEHLERPUNKT
;        GOTO    SU
;        MOVLW   D'0'
;        MOVWF   Z_H
;        GOTO    RECHN

;SU      MOVLW   D'240'      ;AUCH SCHREIBBAR ALS H'F0'
;        SUBWF   Z_H, W
;        BTFSC   STATUS, C   ;KLEINER ALS 240MS SONST FEHLERPUNKT
;        GOTO    VOR1
;        MOVLW   D'150'      ;160
;        SUBWF   Z_H, W
;        BTFSS   STATUS, C   ;GRER ALS 160MS SONST FEHLERPUNKT
;        GOTO    VOR1
;        MOVLW   D'1'
;        MOVWF   Z_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------------------------------------------
;IN DEN IMPULS-LAENGEN-GRENZEN "Z_H" AUSWERTEN
        MOVLW   IMPULS_LOW_DOWN     ;D'60'
        SUBWF   Z_H, W
        BTFSS   STATUS, C           ;GRER ALS 60MS SONST FEHLER
        GOTO    VOR1
        MOVLW   IMPULS_LOW_UP       ;D'140'
        SUBWF   Z_H, W
        BTFSC   STATUS, C           ;KLEINER ALS 140MS SONST FEHLER
        GOTO    SU
        MOVLW   D'0'                ;LOGISCH LOW ODER 0
        MOVWF   Z_H
        GOTO    RECHN

SU      MOVLW   IMPULS_HIGH_UP      ;D'240'
        SUBWF   Z_H, W
        BTFSC   STATUS, C           ;KLEINER ALS 240MS SONST FEHLER
        GOTO    VOR1
        MOVLW   IMPULS_HIGH_DOWN    ;D'160'
        SUBWF   Z_H, W
        BTFSS   STATUS, C           ;GRER ALS 160MS SONST FEHLER
        GOTO    VOR1
        MOVLW   D'1'                ;LOGISCH HIGH ODER 1
        MOVWF   Z_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
RECHN   MOVLW   D'59'       ;BEI >= 59 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSC   STATUS, C
        GOTO    D_ENDE

        MOVLW   D'16'       ;BEI <= 16 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSS   STATUS, C
        GOTO    D_ENDE


;------------ JETZT GEHTS LOS ---------------------------------------

        MOVLW   D'16'       ;ZEITUMSTELLUNG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI00
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI01
        BSF     MERK, BIT0
        GOTO    D_ENDE

MI01    BCF     MERK, BIT0
        GOTO    D_ENDE

MI00    MOVLW   D'17'       ;WINTER/SOMMER-ZEIT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI03
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI02
        BSF     SZ, BIT0
        GOTO    D_ENDE  

MI02    BCF     SZ, BIT0
        GOTO    D_ENDE

MI03    MOVLW   D'42'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI04
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI05
        BSF     WOC, BIT0
        GOTO    D_ENDE  

MI05    BCF     WOC, BIT0
        GOTO    D_ENDE

MI04    MOVLW   D'43'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI06
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI07
        BSF     WOC, BIT1
        GOTO    D_ENDE  

MI07    BCF     WOC, BIT1
        GOTO    D_ENDE

MI06    MOVLW   D'44'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS01
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI08
        BSF     WOC, BIT2
        GOTO    D_ENDE  

MI08    BCF     WOC, BIT2
        GOTO    D_ENDE


AS01    MOVLW   D'36'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS03
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS02
        BSF     KALT, BIT0
        GOTO    A_ENDE  

AS02    BCF     KALT, BIT0
        GOTO    A_ENDE

AS03    MOVLW   D'37'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS05
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS04
        BSF     KALT, BIT1
        GOTO    D_ENDE  

AS04    BCF     KALT, BIT1
        GOTO    D_ENDE

AS05    MOVLW   D'38'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS07
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS06
        BSF     KALT, BIT2
        GOTO    D_ENDE  

AS06    BCF     KALT, BIT2
        GOTO    D_ENDE

AS07    MOVLW   D'39'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS09
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS08
        BSF     KALT, BIT3
        GOTO    D_ENDE  

AS08    BCF     KALT, BIT3
        GOTO    D_ENDE

AS09    MOVLW   D'40'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS11
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS10
        BSF     KALT, BIT4
        GOTO    D_ENDE  

AS10    BCF     KALT, BIT4
        GOTO    D_ENDE

AS11    MOVLW   D'41'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ00
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS12
        BSF     KALT, BIT5
        GOTO    D_ENDE  

AS12    BCF     KALT, BIT5
        GOTO    D_ENDE


AZ00    MOVLW   D'45'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ02
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ01
        BSF     MONA, BIT0
        GOTO    D_ENDE  

AZ01    BCF     MONA, BIT0
        GOTO    D_ENDE


AZ02    MOVLW   D'46'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ04
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ03
        BSF     MONA, BIT1
        GOTO    D_ENDE  

AZ03    BCF     MONA, BIT1
        GOTO    D_ENDE


AZ04    MOVLW   D'47'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ06
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ05
        BSF     MONA, BIT2
        GOTO    D_ENDE  

AZ05    BCF     MONA, BIT2
        GOTO    D_ENDE


AZ06    MOVLW   D'48'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ08
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ07
        BSF     MONA, BIT3
        GOTO    D_ENDE  

AZ07    BCF     MONA, BIT3
        GOTO    D_ENDE


AZ08    MOVLW   D'49'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ10
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ09
        BSF     MONA, BIT4
        GOTO    D_ENDE  

AZ09    BCF     MONA, BIT4
        GOTO    D_ENDE



AZ10    MOVLW   D'50'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ12
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ11
        BSF     JAR, BIT0
        GOTO    D_ENDE  

AZ11    BCF     JAR, BIT0
        GOTO    D_ENDE


AZ12    MOVLW   D'51'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ14
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ13
        BSF     JAR, BIT1
        GOTO    D_ENDE  

AZ13    BCF     JAR, BIT1
        GOTO    D_ENDE


AZ14    MOVLW   D'52'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ16
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ15
        BSF     JAR, BIT2
        GOTO    D_ENDE  

AZ15    BCF     JAR, BIT2
        GOTO    D_ENDE


AZ16    MOVLW   D'53'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ18
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ17
        BSF     JAR, BIT3
        GOTO    D_ENDE  

AZ17    BCF     JAR, BIT3
        GOTO    D_ENDE


AZ18    MOVLW   D'54'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ20
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ19
        BSF     JAR, BIT4
        GOTO    D_ENDE  

AZ19    BCF     JAR, BIT4
        GOTO    D_ENDE


AZ20    MOVLW   D'55'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ22
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ21
        BSF     JAR, BIT5
        GOTO    D_ENDE  

AZ21    BCF     JAR, BIT5
        GOTO    D_ENDE


AZ22    MOVLW   D'56'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ24
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ23
        BSF     JAR, BIT6
        GOTO    D_ENDE  

AZ23    BCF     JAR, BIT6
        GOTO    D_ENDE


AZ24    MOVLW   D'57'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI000
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ25
        BSF     JAR, BIT7
        GOTO    D_ENDE  

AZ25    BCF     JAR, BIT7
        GOTO    D_ENDE





MI000   MOVLW   D'21'       ;1MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I11
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT0
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA0
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA0     BSF     PAR, BIT0
        GOTO    D_ENDE

I11     MOVLW   D'22'       ;2MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I12
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT1
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA1
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA1     BSF     PAR, BIT0
        GOTO    D_ENDE


I12     MOVLW   D'23'       ;4MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I13
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT2
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA2
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA2     BSF     PAR, BIT0
        GOTO    D_ENDE

I13     MOVLW   D'24'       ;8MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I14
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT3
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA3
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA3     BSF PAR, BIT0
        GOTO    D_ENDE


I14     MOVLW   D'25'       ;10MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I15
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT4
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA4
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA4     BSF     PAR, BIT0
        GOTO    D_ENDE


I15     MOVLW   D'26'       ;20MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I16
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT5
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA5
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA5     BSF     PAR, BIT0
        GOTO    D_ENDE


I16     MOVLW   D'27'       ;40MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I17
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT6
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA6
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA6     BSF     PAR, BIT0
        GOTO    D_ENDE


I17     MOVLW   D'28'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II1
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z   ;
        GOTO    IP1
        BTFSS   PAR, BIT0   ;
        GOTO    IP2
        BSF     OK, BIT0
        GOTO    D_ENDE

IP2     BCF     OK, BIT0
        GOTO    VOR

IP1     BTFSC   PAR, BIT0
        GOTO    IP3
        BSF     OK, BIT0
        GOTO    D_ENDE

IP3     BCF OK, BIT0
        GOTO    VOR

II1     MOVLW   D'29'       ;1H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II2
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT0
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA7
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA7     BSF     PAR, BIT1
        GOTO    D_ENDE

II2     MOVLW   D'30'       ;2H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II3
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT1
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA9
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA9     BSF     PAR, BIT1
        GOTO    D_ENDE

II3     MOVLW   D'31'       ;4H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II4
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT2
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA10
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA10    BSF     PAR, BIT1
        GOTO    D_ENDE


II4     MOVLW   D'32'       ;8H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II5
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT3
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA11
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA11    BSF     PAR, BIT1
        GOTO    D_ENDE

II5     MOVLW   D'33'       ;10H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II6
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT4
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA12
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA12    BSF     PAR, BIT1
        GOTO    D_ENDE

II6     MOVLW   D'34'       ;20H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II7
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT5
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA13
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA13    BSF     PAR, BIT1
        GOTO    D_ENDE


II7     MOVLW   D'35'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    A_ENDE
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    XIP1
        BTFSS   PAR, BIT1
        GOTO    XIP2
        BSF     OK, BIT1
        GOTO    D_ENDE

XIP2    BCF     OK, BIT1
        GOTO    VOR

XIP1    BTFSC   PAR, BIT1
        GOTO    XIP3
        BSF     OK, BIT1
        GOTO    D_ENDE

XIP3    BCF     OK, BIT1
        GOTO    VOR

A_ENDE  MOVLW   D'36'       ;AUSWERTEN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE

;AUSWERTEN
        MOVLW   0X07        ;KNNTE MAN WEGLASSEN
        SUBWF   OK, W
        BTFSS   STATUS, Z
        GOTO    VOR

;-------------- ANZEIGE JA ODER NEIN ------------------------------------------

        INCF    ZUST, F
    
        MOVLW   D'1'
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    GO1

;-------------- MERKER FR ZEITUMSTELLUNG BEI UNGELEICHHEIT -------------------
    
        MOVLW   0X45
        SUBWF   MIN, W
        BTFSC   STATUS, C   ;KLEINER GLEICH DER 45-TEN MIN SPRUNG
        GOTO    STA1        ;HIER GRER DER 45-TEN MIN
    
        MOVLW   0X30
        SUBWF   MIN, W
        BTFSS   STATUS, C   ;GRER 30MIN SPRUNG
        GOTO    STA
    
        BTFSS   MERK, BIT0  ;ALSO JETZT ZWISCHEN DER 30. BIS 45.-TEN MIN
        GOTO    STA3
        BSF     MERK, BIT1
        GOTO    STA

STA3    BCF     MERK, BIT1
        GOTO    STA

STA1    BTFSS   MERK, BIT1
        GOTO    STA2
        BTFSS   MERK, BIT0
        GOTO    STA2
        GOTO    STA

STA2    BCF MERK, BIT1

                       ;VON 30-45MIN WIRD BIT1 HIGH GESETZT
                       ;UND VON 45-59MIN MU BIT1 + BIT0 HIGH SEIN
                       ;-AB 00-30MIN BLEIBT BIT1 GESETZT BIS UNGLEICHHEIT AUFTRITT
                       ; UND WIRD DANN SOFORT ANGEZEIGT

;-------------- MIN+H VERGLEICH ----------------------------------------------

STA     MOVF    MIN, W
        MOVWF   MIN_V
        MOVF    H, W
        MOVWF   H_V

LLOP1   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT // JETZT NICHT MEHR. TROTZDEM DRIN WEGEN QUARZ-ZEIT
        BTFSC   INTCON, GIE
        GOTO    LLOP1

        ;MOVLW   H'08'           ;ADRESSE SPEICHERN NEUES PCLATH
        ;MOVWF   PCLATH
        CALL    PLUS1
        ;MOVLW   H'05'           ;ADRESSE SPEICHERN NEUES PCLATH
        ;MOVWF   PCLATH
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN
    
        MOVF    I_MIN, W
        SUBWF   MIN_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_1
        MOVF    I_H, W
        SUBWF   H_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_1
    
        MOVLW   D'100'          ;ALLES OK KANN MAN IN DER MIN-LUECKE ANZEIGEN
        MOVWF   ZUST
        GOTO    D_ENDE

GO1     MOVLW   D'2'
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    GO3
    
        MOVF    MIN_1, W
        MOVWF   MIN_V
        MOVF    H_1, W
        MOVWF   H_V

LLOP2   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT //JETZT NICHT MEHR. TROTZDEM DRIN WEGEN QUARZ-ZEIT
        BTFSC   INTCON, GIE
        GOTO    LLOP2

        ;MOVLW   H'08'           ;ADRESSE SPEICHERN NEUES PCLATH
        ;MOVWF   PCLATH
        CALL    PLUS1
        ;MOVLW   H'05'           ;ADRESSE SPEICHERN NEUES PCLATH
        ;MOVWF   PCLATH
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN
    
        MOVF    I_MIN, W
        SUBWF   MIN_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_2
        MOVF    I_H, W
        SUBWF   H_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_2

ZUR     MOVLW   D'100'          ;ALLES OK KANN MAN IN DER MIN-LUECKE ANZEIGEN
        MOVWF   ZUST
        GOTO    D_ENDE

GO_F_1  BTFSS   MERK, BIT1      ;MERKER FR UNGLEICHHEIT ==> ZEITUMSTELLUNG
        GOTO    GOF1
        BCF     MERK, BIT0
        BCF     MERK, BIT1
        GOTO    ZUR

GOF1    MOVF    I_MIN, W
        MOVWF   MIN_1
        MOVF    I_H, W
        MOVWF   H_1
        GOTO    D_ENDE

GO_F_2  MOVF    I_MIN, W
        MOVWF   MIN_1
        MOVF    I_H, W
        MOVWF   H_1
    
        MOVLW   D'1'
        MOVWF   ZUST
        GOTO    D_ENDE

GO3     MOVLW   D'0'
        MOVWF   ZUST
        GOTO    D_ENDE

;-----------------------------------------------------------------------------

VOR1    BCF OK, BIT2    ;FEHLER MERKEN RAHMEN < >
VOR ;BSF PORTB, FEHLER   ;PARITT STIMMT NICHT PUNKT WIRD SOFORT
                ;ANGEZEIGT UND GEMERKT

        MOVLW   H'85'                  
        CALL    BEFEHL
        MOVLW   H'2C'
        CALL    DATEN


D_ENDE  NOP
        ENDM

;------------------------- ENDE MACROS -----------------------------------------------



    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERR         ; SPRUNG ZUM INTERRUPTPROGRAMM

    ORG 0X0010
;*****************************************************************************
;*                              INTERRUPTPROGRAMM                            *
;*                              22.09.02                                     *
;*****************************************************************************

INTERR  PUSH
        BCF T1CON, TMR1ON               ;STOP TIMER1        ;4T + 8TINTERRUPT? JUSTAGE
        BCF PIR1, TMR1IF                ;OVERFLOW 0 MACHEN  ;4T
        BSF INTCON, PEIE                ;ZUR SICHERHEIT PERIPH. INTERRUPT ZULASSEN
        MOVLW   0XD0                    ;4T
        MOVWF   TMR1L                   ;4T
        MOVLW   0X0B                    ;4T
        MOVWF   TMR1H                   ;4T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JUSTAGE GENDERT
        
;        NOP                             ;4T ZUR JUSTAGE
;        NOP                             ;4T
;        NOP                             ;4T
;        NOP                             ;4T
    
;        NOP                             ;4T
;        NOP                             ;4T
    
        
;        NOP
;        NOP
;        NOP
;        NOP
;        NOP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
        MOVLW   0X31        ;+STEUERBITS FR DIESEN TIMER   ;4T
        MOVWF   T1CON       ;START TIMER1       ;4T GESAMT=14*4T + 1*8T=64T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;VON 7UHR BIS 22UHR PIEPS
        MOVLW   0X00
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    WEITERAA

        MOVLW   STELL_AB_HIER        
        SUBWF   H, W
        BTFSS   STATUS, C   ;GRER GLEICH ALS 7UHR DANN CARRY AUF HIGH
        GOTO    WEITERAA
        MOVLW   STELL_BIS_HIER+1      
        SUBWF   H, W
        BTFSC   STATUS, C   ;KLEINER ALS 22UHR (ALSO 21UHR GEHT NOCH) DANN CARRY AUF LOW
        GOTO    WEITERAA

        MOVLW   0X00
        SUBWF   SEC, W
        BTFSS   STATUS, Z
        GOTO    WEITERAA
        BSF     PORTA, BIT0
        GOTO    QKJ

WEITERAA BCF     PORTA, BIT0
        GOTO    QKJ

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

QKJ     DECF    HELP0, F    ;SEKUNDEN-ERKENNUNG // SPRUNG BEI DEM ENTSPRECHEND ???? KOENNTE FEHLER SEIN

        MOVF    HELP0, W
        SUBLW   D'1'
        BTFSC   STATUS, Z
        GOTO    ZAEL

        MOVF    HELP0, W
        SUBLW   D'2'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'3'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'4'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'5'
        BTFSC   STATUS, Z
        GOTO    NO_SEC

        MOVF    HELP0, W
        SUBLW   D'6'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'7'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W         
        SUBLW   D'8'
        BTFSC   STATUS, Z
        GOTO    QEN

; BEI 1 ZEIT ZHLEN, SIEHE GLEICH UNTERHALB


;----------- SEKUNDEN, MINUTEN UND STUNDEN ZHLUNG DER NORMALEN QUARZ-ZEIT ---

ZAEL    MOVF    SEC, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP0

        MOVF    SEC, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP1

PPP0    MOVF    SEC, W
        ADDLW   0X01

PPP1    MOVWF   SEC
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    MMA

        CLRF    SEC         ;
        MOVF    MIN, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP2

        MOVF    MIN, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP3

PPP2    MOVF    MIN, W
        ADDLW   0X01

PPP3    MOVWF   MIN
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    MMA

        CLRF    MIN
        MOVF    H, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP4

        MOVF    H, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP5

PPP4    MOVF    H, W
        ADDLW   0X01

PPP5    MOVWF   H
        SUBLW   0X24
        BTFSS   STATUS, Z
        GOTO    MMA
        CLRF    H

MMA     


;==========================================================
;SEC-DARSTELLEN
            MOVF    SEC, W                  
            MOVWF   HELP2

            MOVLW   H'87'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'86'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;MIN
            MOVF    MIN, W                  
            MOVWF   HELP2

            MOVLW   H'84'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'83'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;H
            MOVF    H, W                  
            MOVWF   HELP2

            MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    CCBN

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    CCCBN

CCBN        MOVLW   H'20'
CCCBN       CALL    DATEN



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;NEU-PIC16F628
;DIE ABFRAGE DER SCHALTZEIT KOMMT HIER REIN

SSS101  BTFSC   MERB, BIT0      ;ZULASSUNG FUER DAS SCHALTEN, DIE DCF77-ZEIT WURDE ERKANNT BZW. DIE UHR GESTELLT BEI HIGH
        GOTO    KMML

;GESICHERTE WOCHE RAUSHOLEN
;        MOVF    S_WOC, W
;        MOVWF   WOC

        BTFSC   MERB, BIT7      ;BEI AUS-ZUSTAND WIRD EINSCHALT-TABELLE ABGEFRAGT ....
        GOTO    AUS1

;VERGLEICHEN BEI EINSCHALTEN
        CLRF    ZAE             ;ZAEHLER BEGINNT BEI NULL
SPUCA   MOVLW   H'0A'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    SEC_EIN
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVLW   0XFF                ;ENDEERKENNUNG DER TABELLE
        SUBWF   MERA, W         ;DAS ENDEBYTE MUSS AM ENDE DER TABELLE FF HEX SEIN
        BTFSC   STATUS, Z
        GOTO    KMML

        MOVF    MERA, W
        SUBWF   SEC, W
        BTFSS   STATUS, Z
        GOTO    SPUC22

        MOVLW   H'09'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    MIN_EIN
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    SPUC22

        MOVLW   H'08'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    H_EIN
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   H, W
        BTFSS   STATUS, Z
        GOTO    SPUC22



;""""""""""""""""""""""""""""""""""""""""""""
;WOCHENTAGS-ANALYSE
;        MOVLW   H'0E'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH
;        CALL    WOCH_EIN
;        MOVWF   MERA
;        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH

;        MOVLW   0X01              ;MONTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ1

;        BTFSC   MERA, BIT0
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ1    MOVLW   0X02              ;DIENSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ2

;        BTFSC   MERA, BIT1
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ2    MOVLW   0X03              ;MITTWOCH
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ3

;        BTFSC   MERA, BIT2
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ3    MOVLW   0X04              ;DONNERSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ4

;        BTFSC   MERA, BIT3
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ4    MOVLW   0X05             ;FREITAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ5

;        BTFSC   MERA, BIT4
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ5    MOVLW   0X06            ;SAMSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ6

;        BTFSC   MERA, BIT5
;        GOTO    ZSCHALT
;        GOTO    SPUC22

;ZZQ6    MOVLW   0X07            ;SONNTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    SPUC22

;        BTFSC   MERA, BIT6
;        GOTO    ZSCHALT
;        GOTO    SPUC22


;""""""""""""""""""""""""""""""""""""""""""""
        
ZSCHALT BCF     PORTA, SCHALT       ;FR LOW ALS EIN  ;EINSCHALTEN DA SEC, MIN + H AUS TABELLE BEREINSTIMMT
        ;BSF     PORTA, SCHALT       ;FR HIGH ALS EIN

        BSF     MERB, BIT7
        GOTO    KMML

SPUC22  INCF    ZAE, F              ;ZAEHLER UM 1 ERHHEN
        GOTO    SPUCA



;VERGLEICHEN BEI AUSSCHALTEN
AUS1    NOP                     ;CLRF    ZAE             ;ZAEHLER BEGINNT BEI NULL
SPUKA   MOVLW   H'0D'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    SEC_AUS
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        ;MOVLW   0XFF                ;ENDEERKENNUNG DER TABELLE
        ;SUBWF   MERA, W         ;DAS ENDEBYTE MUSS AM ENDE DER TABELLE FF HEX SEIN
        ;BTFSC   STATUS, Z
        ;GOTO    KMML

        MOVF    MERA, W
        SUBWF   SEC, W
        BTFSS   STATUS, Z
        GOTO    SPUK22

        MOVLW   H'0C'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    MIN_AUS
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    SPUK22

        MOVLW   H'0B'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    H_AUS
        MOVWF   MERA
        MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   H, W
        BTFSS   STATUS, Z
        GOTO    SPUK22



;""""""""""""""""""""""""""""""""""""""""""""
;WOCHENTAGS-ANALYSE
;        MOVLW   H'0F'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH
;        CALL    WOCH_AUS
;        MOVWF   MERA
;        MOVLW   H'01'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH

;        MOVLW   0X01              ;MONTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQA

;        BTFSC   MERA, BIT0
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQA    MOVLW   0X02              ;DIENSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQB

;        BTFSC   MERA, BIT1
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQB    MOVLW   0X03              ;MITTWOCH
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQC

;        BTFSC   MERA, BIT2
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQC    MOVLW   0X04              ;DONNERSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQD

;        BTFSC   MERA, BIT3
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQD    MOVLW   0X05             ;FREITAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQE

;        BTFSC   MERA, BIT4
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQE    MOVLW   0X06            ;SAMSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQF

;        BTFSC   MERA, BIT5
;        GOTO    ZSCHALT12
;        GOTO    SPUK22

;ZZQF    MOVLW   0X07            ;SONNTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    SPUK22

;        BTFSC   MERA, BIT6
;        GOTO    ZSCHALT12
;        GOTO    SPUK22


;""""""""""""""""""""""""""""""""""""""""""""
                
ZSCHALT12        BSF     PORTA, SCHALT       ;BEI LOW ALS EIN ;AUSSCHALTEN DA SEC, MIN + H AUS TABELLE BEREINSTIMMT
                 ;BCF     PORTA, SCHALT       ;BEI HIGH ALS EIN

        BCF     MERB, BIT7
        GOTO    KMML

SPUK22  NOP                          ;INCF    ZAE, F              ;ZAEHLER UM 1 ERHHEN
                                     ;GOTO    SPUKA


;-------------------------------------------------------------
;ENDE DER ABFRAGE FR NEU-PIC16F628

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



KMML        MOVLW   D'9'
            MOVWF   HELP0

;DOPPELPUNKT WIRD ANGEZEIGT
            MOVLW   H'82'                  
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN

            GOTO    EEE

NO_SEC      BTFSS   DCF_DA, BIT0    ;BEI DCF_DA=1 BLINKT ES
            GOTO    EEE

;DOPPELPUNKT WIRD AUSGESCHALTET
            MOVLW   H'82'                  
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN


EEE         BTFSS   MERK, BIT7      ;KURZZEITIG BEI 00SEC BLINKEN,
            GOTO    QEN             ;WENN DIE DCF-ZEIT ?BERNOMMEN
            MOVLW   0X00            ;NUR EINE HALBE SEC BLINKEN
            SUBWF   SEC, W
            BTFSS   STATUS, Z
            GOTO    QEE

;FEHLER KOMMA
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2C'
            CALL    DATEN
            GOTO    QEN

QEE         BCF MERK, BIT7

;FEHLER PUNKT
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


QEN         POP
            RETFIE

;*****************************************************************************
;*                              HAUPTPROGRAMM                                *
;*                              22.09.02                                     *
;*****************************************************************************
MAIN        BCF STATUS, RP0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        BSF     MERB, BIT0          ;ZULASSUNG WANN GESCHALTET WERDEN SOLL
        BCF     MERB, BIT7          ;MERKER FUER AUS-ZUSTAND VON RA1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;----------- INIT ALLE PORT'S ----------------------------------------------------

;            CLRF    PORTA
                           
            CLRF    PORTB
            MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
            MOVWF   CMCON
            BSF     STATUS, RP0             ;BANK1 
            MOVLW   B'11110000'             ;INIT INPUT/OUTPUT AM PORTA --> ALLES EINGAENGE AUSSER  RA0 RA1 RA2 RA3 ALS AUSGAENGE
            MOVWF   TRISA
            MOVLW   B'00000000'             ;INIT I/O PORTB ALLES AUSGAENGE FUER DATENBUS             
            MOVWF   TRISB
            BCF     STATUS, RP0             ;BANK0

;----------- INIT 15 SEC PAUSE DAMIT DCF-77-EMPFNGER GUT EINSCHWINGT -------------
;----------- ES WIRD TIMER1 GENOMMEN ---------------------------------------------
;----------- DIE ZEIT IST 500MS BIS DAS OVERFOW-BIT IN PIR1 (TMR1F) BIT0 ZU 1 WIRD
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
        
            CLRF    INTCON              ;TIMER1 KEIN INTERRUPT
            BSF     STATUS, RP0         ;BANK1
            CLRF    PIE1                ;INTERRUPT-ENABLE-BIT IST DISABLE (MASKE)
            BCF     STATUS, RP0         ;BANK0
            BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN
            MOVLW   0XDB                ;500MS/32=15.625MS/0.25MYS=62500TAKTE
            MOVWF   TMR1L               ;0X10000-62500(0XF424)=0X0BDC  +2(JUSTAGE 32T*2=64T)==0X0BDE
            MOVLW   0X0B
            MOVWF   TMR1H
            MOVLW   0X31                ;PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
            MOVWF   T1CON               ;START TIMER1

            CLRF    PORTA
            BSF     PORTA, SCHALT       ;BEI LOW ALS EIN // GRUNDZUSTAND AM ANFANG
            ;BCF     PORTA, SCHALT       ;BEI HIGH ALS EIN // GRUNDZUSTAND AM ANFANG

            CLRF    PORTB

;ZEITSCHLEIFE VON 50MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 MIT HELP0=4
            MOVLW   D'4'
            MOVWF   HELP0

S3          MOVLW   D'200'                  ;UNGEFAEHR 250SEC * 200 = 50MSEC
            MOVWF   HELP2

S0          MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1                   
S1          NOP                             ;T=4
            DECFSZ  HELP1, F                ;T=4
            GOTO    S1                      ;T=4 ODER 8 ?
            DECFSZ  HELP2, F
            GOTO    S0          
            DECFSZ  HELP0, F
            GOTO    S3
;ENDE ZEITSCHLEIFE

;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'28'                   ;FUNCTION SET  4-BIT-LAENGE, 2ZEILIG, 5X7FONT
            CALL    BEFEHL
 
;            MOVLW   H'06'                   ;ENTRY MODE    DISPLAY SHIFT ON DATA, INCREMENTIEREND
;            CALL    BEFEHL

            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL

            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL

;ZEITSCHLEIFE VON 2,5MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
            MOVLW   D'80'                   ;UNGEFAEHR 250SEC * 10 = 2,5MSEC  JETZT ABER 80
            MOVWF   HELP2

DD2         MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1
DD21        NOP
            DECFSZ  HELP1, F
            GOTO    DD21
            DECFSZ  HELP2, F
            GOTO    DD2          
;ENDE ZEITSCHLEIFE

;----------- LCD-DOT-MATRIX-AUSGEBEN ------------------------

;WEGGEMACHT "BEGRSSUNG"

;----------- 15 SEC PAUSENZEIT ABFRAGEN ------------------------------------------

;WEGGEMACHT

;----------- INIT 0.5 SEC --------------------------------------------------------
;----------- ES WIRD TIMER1 GENOMMEN MIT INTERRUPT -------------------------------
;----------- ZEITBASIS DER NORMALEN QUARZ-UHR ------------------------------------

E_PAUSE BCF     PIR1, TMR1IF        ;4T OVERFLOW 0 MACHEN
        BSF     INTCON, GIE         ;4T GLOBALER INTERRUPT ENABLE + PERIPHERAL INTERRUPT
        BSF     INTCON, PEIE        ;4T
        BSF     STATUS, RP0         ;4T BANK1
        BSF     PIE1, TMR1IE        ;4T TIMER1 OVERFLOW-INTERRUPT ENABLE
        BCF     STATUS, RP0         ;4T BANK0
        MOVLW   0XD0                ;4T 500MS/32=15.625MS/0.25MYS=62500TAKTE
        MOVWF   TMR1L               ;4T 65536(0X10000)-62500(0XF424)=3036(0X0BDC)
                                    ;      +2(JUSTAGE 32T*2=64T)==0X0BDE
        MOVLW   0X0B                ;4T
        MOVWF   TMR1H               ;4T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;1. JUSTAGE
;2,5SEC IN 15H ZU VIEL
;15H*60=900MIN*60=54000SEC*2=108000ZYKLEN
;2,5SEC/108000ZYK.=23.148MYKROSEC
;23.148MYKROSEC/0.25=92TAKTE ALSO T
;92/32T=2.8 GENOMMEN 3
;ALSO 0X0BD8+3=0X0BDB KEINE NOP'S

;2. JUSTAGE
;0,8 SEC IN 48H ZU VIEL
;48H*60=2880MIN*60=172800SEC*2=345600ZYKLEN
;0,8 SEC/ 345600ZYK.=2,314MYKROSEC
;2.314MYKROSEC/0.25=9.256TAKTE ALSO T
;9.256/4T=2.3 GENOMMEN 2 * NOP
;ALSO 2*NOP (8T) HINZUGEFGT

;3. JUSTAGE
;1 SEC IN 24H ZU WENIG
;24H*60=1440MIN*60=86400SEC*2=172800ZYKLEN
;1 SEC/ 172800ZYK.=5,787MYKROSEC
;5,787MYKROSEC/0.25=23,14TAKTE ALSO T
;23,14/4T=5,78 GENOMMEN 5 * NOP
;ALSO 5*NOP (20T) HINZUGEFGT

;WEGEN CALL PLUS1 NICHT RETURN 0X0800 GRER
    ;NOP
    ;NOP
    
    ;NOP
    ;NOP
    ;NOP
    ;NOP
    ;NOP


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





    MOVLW   0X31        ;4T PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
    MOVWF   T1CON       ;4T START TIMER1
                        ;GESAMT: 32T+13*4T=84T //20*0.25MYS=5MYS ZU LANG
    MOVLW   D'9'
    MOVWF   HELP0



;----------- GRUNDEINSTELLUNG FR NORMAL-QUARZ-UHR -------------------------------
;----------- UND ANZEIGE ---------------------------------------------------------


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANZEIGE RAUS GENOMMEN

            CLRF   H
            CLRF   MIN
            CLRF   SEC
;========================================================

;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'28'                   ;FUNCTION SET  4-BIT-LAENGE, 2ZEILIG, 5X7FONT
            CALL    BEFEHL
 
            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL

            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL

;ZEITSCHLEIFE VON 2,5MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
            MOVLW   D'80'                   ;UNGEFAEHR 250SEC * 10 = 2,5MSEC  JETZT ABER 80
            MOVWF   HELP2

DDM2        MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1
DDM21       NOP
            DECFSZ  HELP1, F
            GOTO    DDM21
            DECFSZ  HELP2, F
            GOTO    DDM2          
;ENDE ZEITSCHLEIFE


            MOVLW   H'80'                   ;ADRESSE 0 
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN

            MOVLW   H'81'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'82'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN

            MOVLW   H'83'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'84'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'85'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN

            MOVLW   H'86'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'87'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

;========================================================


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            CLRF    DCF_DA          ;DCF IST NICHT DA, ES BLINKT NICHT
;    BCF PORTB, FEHLER   ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'2E'
;            CALL    DATEN


            CLRF    MERK
            BSF     MERK, BIT6      ;BEI NICHT BEREINSTIMMUNG MIN/H 1.-TES OK ZULASSEN
                                    ;ABER NUR BEIM START

;----------- DCF-SIGNAL DECODIEREN -----------------------------------------------
;----------- DCF-SEC-IMPULS-ANFANG FINDEN ----------------------------------------

SYN         CLRF    ZUST
            CLRF    Z_LL
            CLRF    Z_LH

            BCF     DCF_DA, BIT0    ;DCF IST NICHT DA, ES BLINKT NICHT
;    BCF PORTB, FEHLER   ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'66'
;            CALL    DATEN


            MOVLW   D'4'
            MOVWF   X4
 
SEC0        BCF     INTCON, GIE ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
            BTFSC   INTCON, GIE
            GOTO    SEC0
            MS1
            BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCHA        BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
            GOTO    SCHA

            DECFSZ  X4, F
            GOTO    SEC0

            BTFSC   PORTA, BIT4
            GOTO    SEC1            ;HIGH-IMPULS-BEGINN ERKANNT
            INCF    Z_LL, F         ;LOW-IMPULS ZHLEN
            BTFSS   STATUS, Z       ;BERTRAG VON FF --> 00
            GOTO    SEC0
            BSF     Z_LH, BIT0
            GOTO    SEC0

SEC1        BTFSC   Z_LH, BIT0      ;GRER ALS FF LOW-SEC-LCKE
            GOTO    LUECKE

SEC2        MOVLW   0X02            ;GRER ALS 02 LOW-SEC-LCKE
            SUBWF   Z_LL, W
            BTFSS   STATUS, C
            GOTO    SYN

;------------ DCF-MINUTEN LCKE FINDEN ------------------------------------------

LUECKE      CLRF    Z_LL            ;MTE MIT HIGH IMPULS BEGINNEN
            CLRF    Z_LH            ;ES WERDEN NUR DIE LOW-ZEITEM GEMESSEN

L1          BTFSC   PORTA, BIT4
            GOTO    L2

            MOVLW   D'4'
            MOVWF   X4
 
LOOP1       BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
            BTFSC   INTCON, GIE
            GOTO    LOOP1
            MS1
            BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH         BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
            GOTO    SCH

            DECFSZ  X4, F
            GOTO    LOOP1

            INCFSZ  Z_LL, F
            GOTO    L1
            INCFSZ  Z_LH, F
            GOTO    L1
            GOTO    SYN             ;DCF IST NICHT DA, AUSWERTUNG NACH 0XFFFF 65.535MS
                                    ;ES BLINKT NICHT

L2          MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MS
            SUBWF   Z_LH, W
            BTFSS   STATUS, C
            GOTO    LUECKE
 ;   BCF PORTB, FEHLER       ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'2E'
;            CALL    DATEN

            BSF DCF_DA, BIT0        ;ES BLINKT

;------------ DCF-IMPULSE ERFASSEN ---------------------------------------------

IMPULS  CLRF    Z_IMP       ;BEGINNT MIT HIGH-IMPULS
        CLRF    I_MIN
        CLRF    I_H
        CLRF    OK
        BSF     OK, BIT2    ;RAHMENFEHLER < > IST IN ORDNUNG, WIRD BEI FEHLER ZURCKGESETZT
        CLRF    PAR         ;UNGERADE PARITT BEGINN IST JETZT 0X00
        CLRF    WOC         ;WOCHENTAG
        CLRF    KALT        ;KALENDERTAG
        CLRF    MONA        ;MONAT
        CLRF    JAR         ;JAHR

I1      CLRF    Z_H
        CLRF    Z_LL
        CLRF    Z_LH

I2      BTFSS   PORTA, BIT4 ;HIGH-IMPULS MESSEN
        GOTO    I10         ;SPRUNG BEI LOW ZUR AUSWERTUNG

        MOVLW   D'4'
        MOVWF   X4
 
LOOP2   BCF INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOOP2
        MS1
        BSF INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH1    BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
        GOTO    SCH1

        DECFSZ  X4, F
        GOTO    LOOP2

        INCFSZ  Z_H, F          ;ACHTUNG HIER KNNTE FEHLER AUFTRETEN --> JETZT NICHT MEHR
        GOTO    I2
        GOTO    SYN

I10     AUSW                    ;AUSWERTUNG

        INCF    Z_IMP, F

I111    BTFSC   PORTA, BIT4 ;LOW-IMPULS ZEITBERSCHREITUNG
        GOTO    I111A

        MOVLW   D'4'
        MOVWF   X4
 
LOOP3   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOOP3
        MS1
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH2    BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
        GOTO    SCH2

        DECFSZ  X4, F
        GOTO    LOOP3

        INCFSZ  Z_LL, F
        GOTO    I111
        INCFSZ  Z_LH, F
        GOTO    I111
        GOTO    SYN             ;ZEITBERSCHREITUNG ES FEHLT DCF

I111A   MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MS
        SUBWF   Z_LH, W
        BTFSS   STATUS, C
        GOTO    I1              ;ES IST EINE SEC VORBEI MIT HIGH + DANN LOW

;--------------- MINUTENLCKE AN DER RICHTIGEN STELLE ----------------------------

        MOVLW   D'59'       ;MIN-LCKEN ERKENNUNG OK???
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    SCHB        ;FEHLER BEI IMPULSANZAHL

;--------------- OB KEIN FEHLER (PARITTBIT 0+1/RAHMEN <> BIT2) ------------------

        MOVLW   0X07
        SUBWF   OK, W
        BTFSS   STATUS, Z
        GOTO    SCHB        ;FEHLER BEI PARITT + RAHMEN

;--------------- OB ZEIT RICHTIG GEMESSEN, DANN DARSTELLEN ----------------------
    
        BTFSS   MERK, BIT6  ;BEI START SOFORT ZULASSEN
        GOTO    LLKM
        BCF MERK, BIT6
        GOTO    LOP11

LLKM    MOVLW   D'100'      ;BEI QUARZZEIT NICHT == GEMESSENER ZEIT
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    NO          ;NICHT ZEIT DARSTELLEN, ZEIT NICHT RICHTIG GEMESSEN
                            ;KEINE BEREINSTIMMUNG

LOP11   CLRF    ZUST    ;JETZT GEHT NORMALE ZEITBEREINSTIMMUNG
        BSF MERK, BIT7      ;VON 00SEC ZU 01SEC FEHLERBLINKEN

;----------- QUARZ-ZEIT RICHTIG STARTEN ------------------------------------------

LOP1    BCF     INTCON, GIE ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOP1
    
        BCF     T1CON, TMR1ON   ;STOP TIMER1        ;4T + 8TINTERRUPT? JUSTAGE
        BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN  ;4T
        BSF     INTCON, PEIE    ;ZUR SICHERHEIT PERIPH. INTERRUPT ZULASSEN
        MOVLW   0XDB        ;4T
        MOVWF   TMR1L       ;4T
        MOVLW   0X0B        ;4T
        MOVWF   TMR1H       ;4T
        MOVLW   0X31        ;+STEUERBITS FR DIESEN TIMER   ;4T
        MOVWF   T1CON       ;START TIMER1       ;4T GESAMT=14*4T + 1*8T=64T
    
        BSF     INTCON, GIE ;INTERRUPT WIEDER ZULASSEN

;----------- ZEIT EXAKT EINSTELLEN -----------------------------------------------

            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL

;ZEITSCHLEIFE VON 2,5MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
            MOVLW   D'80'                   ;UNGEFAEHR 250SEC * 10 = 2,5MSEC  JETZT ABER 80
            MOVWF   HELP2

DD2Z        MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1
DD21Z       NOP
            DECFSZ  HELP1, F
            GOTO    DD21Z
            DECFSZ  HELP2, F
            GOTO    DD2Z          
;ENDE ZEITSCHLEIFE
	    
        CLRF    SEC         ;SEC NULLEN
        MOVF    I_MIN, W
        MOVWF   MIN
        MOVF    I_H, W
        MOVWF   H

;WOCHE SICHERN
;        MOVF    WOC, W
;        MOVWF   S_WOC

;----------- MIN UND H ANZEIGE AUF LCD-PORT'S --------------------------------

;==========================================================
;SEC-DARSTELLEN
            MOVF    SEC, W                  
            MOVWF   HELP2

            MOVLW   H'87'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'86'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;MIN
            MOVF    MIN, W                  
            MOVWF   HELP2

            MOVLW   H'84'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'83'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;H
            MOVF    H, W                  
            MOVWF   HELP2

            MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    CCBN1

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    CCCBN1

CCBN1       MOVLW   H'20'
CCCBN1      CALL    DATEN


;KALENDERTAG DARSTELLUNG
            MOVF    KALT, W                  
            MOVWF   HELP2

            MOVLW   H'C5'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'C4'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    ABN1

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    AABN1

ABN1      MOVLW   H'20'
AABN1     CALL    DATEN

;MONAT
            MOVF    MONA, W                  
            MOVWF   HELP2

            MOVLW   H'C8'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'C7'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;JAHR
            MOVF    JAR, W                  
            MOVWF   HELP2

            MOVLW   H'CD'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'CC'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN


 
;MESZ + MEZ DARSTELLEN
            BTFSC   SZ, BIT0
            GOTO    SZZZ
            
            MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'45'
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'5A'
            CALL    DATEN

            MOVLW   H'8C'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN
            GOTO    KMLLL1

SZZZ        MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'45'
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN

            MOVLW   H'8C'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'5A'
            CALL    DATEN
    
;WOCHENTAG DARSTELLEN
KMLLL1      MOVLW   0X01                    ;MON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK1
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN
            GOTO    KMML1

WKK1        MOVLW   0X02                    ;DIE
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK2
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'44'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'69'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN
            GOTO    KMML1

WKK2        MOVLW   0X03                    ;MIT
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK3
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'69'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'74'
            CALL    DATEN
            GOTO    KMML1

WKK3        MOVLW   0X04                    ;DON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK4
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'44'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN
            GOTO    KMML1

WKK4        MOVLW   0X05                    ;FRE
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK5
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'46'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'72'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN
            GOTO    KMML1

WKK5        MOVLW   0X06                    ;SAM
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK6
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'61'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6D'
            CALL    DATEN
            GOTO    KMML1

WKK6        MOVLW   0X07                    ;SON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    KMML1
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN



KMML1       MOVLW   H'C6'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN
            MOVLW   H'C9'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN
            MOVLW   H'CA'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'32'
            CALL    DATEN
            MOVLW   H'CB'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

;==========================================================

;==========================================================

            



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;NEU-PIC16F628
;DIE ABFRAGE DER SCHALTZEIT KOMMT HIER REIN
;----------------------------------------------------------

SSS10   BCF     MERB, BIT0           ;ZULASSUNG SCHALTEN BEI INTERRUPT

        BTFSC   MERB, BIT7      ;BEI AUS-ZUSTAND WIRD EINSCHALT-TABELLE ABGEFRAGT ....
        GOTO    AUS11

;VERGLEICHEN BEI EINSCHALTEN
        CLRF    ZAE             ;ZAEHLER BEGINNT BEI NULL
SPUCA1  MOVLW   H'0A'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    SEC_EIN
        MOVWF   MERA
        MOVLW   H'05'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVLW   0XFF                ;ENDEERKENNUNG DER TABELLE
        SUBWF   MERA, W         ;DAS ENDEBYTE MUSS AM ENDE DER TABELLE FF HEX SEIN
        BTFSC   STATUS, Z
        GOTO    KMML2

        MOVLW   H'00'
        MOVWF   MERC
        MOVF    MERA, W
        SUBWF   MERC, W
        BTFSS   STATUS, Z
        GOTO    SPUC221

        MOVLW   H'08'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    H_EIN
        MOVWF   MERA
        MOVLW   H'05'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   H, W
        BTFSS   STATUS, Z
        GOTO    SPUC221

        MOVLW   H'09'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    MIN_EIN
        MOVWF   MERA

        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    SPUC221
;        GOTO    ZSCHALT1

;""""""""""""""""""""""""""""""""""""""""""""
;WOCHENTAGS-ANALYSE
;        MOVLW   H'0E'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH
;        CALL    WOCH_EIN
;        MOVWF   MERA
;        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH

;        MOVLW   0X01            ;MONTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ11

;        BTFSC   MERA, BIT0
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ11   MOVLW   0X02           ;DIENSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ21

;        BTFSC   MERA, BIT1
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ21   MOVLW   0X03           ;MITTWOCH
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ31

;        BTFSC   MERA, BIT2
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ31   MOVLW   0X04           ;DONNERSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ41

;        BTFSC   MERA, BIT3
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ41   MOVLW   0X05           ;FREITAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ51

;        BTFSC   MERA, BIT4
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ51   MOVLW   0X06           ;SAMSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQ61

;        BTFSC   MERA, BIT5
;        GOTO    ZSCHALT1
;        GOTO    SPUC221

;ZZQ61   MOVLW   0X07           ;SONNTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    SPUC221

;        BTFSC   MERA, BIT6
;        GOTO    ZSCHALT1
;        GOTO    SPUC221


;""""""""""""""""""""""""""""""""""""""""""""
                
ZSCHALT1 BCF     PORTA, SCHALT      ;BEI LOW ALS EIN ;EINSCHALTEN DA SEC, MIN + H AUS TABELLE BEREINSTIMMT
         ;BSF     PORTA, SCHALT      ;BEI HIGH ALS EIN

        BSF     MERB, BIT7
        GOTO    KMML2

SPUC221 INCF    ZAE, F              ;ZAEHLER UM 1 ERHHEN
        GOTO    SPUCA1



;VERGLEICHEN BEI AUSSCHALTEN
AUS11   NOP                     ;CLRF    ZAE             ;ZAEHLER BEGINNT BEI NULL
;SPUKA1  
        MOVLW   H'0D'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    SEC_AUS
        MOVWF   MERA
        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVLW   0XFF                ;ENDEERKENNUNG DER TABELLE
        SUBWF   MERA, W         ;DAS ENDEBYTE MUSS AM ENDE DER TABELLE FF HEX SEIN
        BTFSC   STATUS, Z
        GOTO    KMML2

        MOVLW   H'00'
        MOVWF   MERC
        MOVF    MERA, W
        SUBWF   MERC, W
        BTFSS   STATUS, Z
        GOTO    SPUK221

        MOVLW   H'0B'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    H_AUS
        MOVWF   MERA
        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   H, W
        BTFSS   STATUS, Z
        GOTO    SPUK221

        MOVLW   H'0C'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH
        CALL    MIN_AUS
        MOVWF   MERA
        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
        MOVWF   PCLATH

        MOVF    MERA, W
        SUBWF   MIN, W
        BTFSS   STATUS, Z
        GOTO    SPUK221


;""""""""""""""""""""""""""""""""""""""""""""
;WOCHENTAGS-ANALYSE
;        MOVLW   H'0F'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH
;        CALL    WOCH_AUS
;        MOVWF   MERA
;        MOVLW   H'06'           ;ADRESSE SPEICHERN NEUES PCLATH
;        MOVWF   PCLATH

;        MOVLW   0X01              ;MONTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQA1

;        BTFSC   MERA, BIT0
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQA1    MOVLW   0X02              ;DIENSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQB1

;        BTFSC   MERA, BIT1
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQB1    MOVLW   0X03              ;MITTWOCH
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQC1

;        BTFSC   MERA, BIT2
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQC1    MOVLW   0X04              ;DONNERSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQD1

;        BTFSC   MERA, BIT3
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQD1    MOVLW   0X05             ;FREITAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQE1

;        BTFSC   MERA, BIT4
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQE1    MOVLW   0X06            ;SAMSTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    ZZQF1

;        BTFSC   MERA, BIT5
;        GOTO    ZSCHALT11
;        GOTO    SPUK221

;ZZQF1    MOVLW   0X07            ;SONNTAG
;        SUBWF   WOC, W
;        BTFSS   STATUS, Z
;        GOTO    SPUK221

;        BTFSC   MERA, BIT6
;        GOTO    ZSCHALT11
;        GOTO    SPUK221


;""""""""""""""""""""""""""""""""""""""""""""
         
ZSCHALT11        BSF     PORTA, SCHALT       ;BEI LOW ALS EIN ;AUSSCHALTEN DA SEC, MIN + H AUS TABELLE BEREINSTIMMT
                 ;BCF     PORTA, SCHALT       ;BEI HIGH ALS EIN

        BCF     MERB, BIT7
        GOTO    KMML2

SPUK221 NOP                         ;INCF    ZAE, F              ;ZAEHLER UM 1 ERHHEN
                                    ;GOTO    SPUKA1


;-------------------------------------------------------------
;ENDE DER ABFRAGE FR NEU-PIC16F628

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



KMML2       MOVLW   D'9'           ;GLEICH BEI START-TIMER
            MOVWF   HELP0

;DOPPELPUNKT WIRD ANGEZEIGT
            MOVLW   H'82'                   
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN
        


;FEHLERPUNKT NICHT DARSTELLEN
NO          MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


            BSF     DCF_DA, BIT0    ;ES BLINKT
            GOTO    IMPULS          ;ES IST 1MIN VORBEI HIER IST MIN-LCKE ERKANNT

SCHB        CLRF    ZUST

;FEHLERPUNKT NICHT DARSTELLEN
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


            BSF     DCF_DA, BIT0    ;ES BLINKT
            GOTO    IMPULS


;*****************************************************************************
;*                              UNTERPROG. DATEN AUSGEBEN AUF DOT-LCD-MODUL  *
;*                              04.05.10                                     *
;*****************************************************************************
DATEN       BSF     PORTA, RS               ;ALS DATEN

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 4SEC ZEITSCHLEIFE
            MOVWF   HELP3
D1          NOP                             ;T=4
            DECFSZ  HELP3, F                ;T=4
            GOTO    D1                      ;T=8    GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP3
DDD1        NOP                             
            DECFSZ  HELP3, F                
            GOTO    DDD1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP3
DDDD1       NOP
            DECFSZ  HELP3, F                ;WIE OBEN  
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE

            RETURN

;*****************************************************************************
;*                              UNTERPROG. BEFEHL AUSGEBEN AUF DOT-LCD-MODUL *
;*                              04.05.10                                     *
;*****************************************************************************
BEFEHL      BCF     PORTA, RS                ;ALS BEFEHL

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 8SEC ZEITSCHLEIFE
            MOVWF   HELP3
B1          NOP                             ;T=4
            DECFSZ  HELP3, F                ;T=4
            GOTO    B1                      ;T=8        GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP3
BBB1        NOP                             
            DECFSZ  HELP3, F                
            GOTO    BBB1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP3
BBBB1       NOP
            DECFSZ  HELP3, F                ;WIE OBEN  
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE
 
            RETURN




;*****************************************************************************
;*                              UNTERPRG. (H UND MIN +1)                     *
;*                              09.10.02                                     *
;*****************************************************************************

PLUS1   MOVF    MIN_V, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    JPP2
    
        MOVF    MIN_V, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    JPP3

JPP2    MOVF    MIN_V, W
        ADDLW   0X01

JPP3    MOVWF   MIN_V
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    EEEND
    
        MOVWF   MIN_V
        MOVF    H_V, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    JPP4
    
        MOVF    H_V, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    JPP5

JPP4    MOVF    H_V, W
        ADDLW   0X01

JPP5    MOVWF   H_V
        SUBLW   0X24
        BTFSS   STATUS, Z
        GOTO    EEEND
        MOVWF   H_V

EEEND   RETURN


;*****************************************************************************
;*                       TABELLE FUER ALLE STUNDEN SCHALTEN EIN              *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0800
H_EIN   MOVLW H'8'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0X800
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 

;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'09'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC

        RETLW 0XFF      ;ENDEKENNZEICHEN    

;*****************************************************************************
;*                       TABELLE FUER ALLE MINUTEN SCHALTEN EIN              *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0900
MIN_EIN MOVLW H'09'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0X900
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 
 
;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'45'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC

        RETLW 0XFF      ;ENDEKENNZEICHEN    

;*****************************************************************************
;*                       TABELLE FUER ALLE SEKUNDEN SCHALTEN EIN             *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0A00
SEC_EIN MOVLW H'0A'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XA00
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 
 
;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'00'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC
              
        RETLW 0XFF      ;ENDEKENNZEICHEN

;*****************************************************************************
;*                       TABELLE FUER ALLE STUNDEN SCHALTEN AUS              *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0B00
H_AUS   MOVLW H'0B'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XB00
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 
                
;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'09'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC

        RETLW 0XFF      ;ENDEKENNZEICHEN

;*****************************************************************************
;*                       TABELLE FUER ALLE MINUTEN SCHALTEN AUS              *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0C00
MIN_AUS MOVLW H'0C'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XC00
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 

;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'45'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC

        RETLW 0XFF      ;ENDEKENNZEICHEN

;*****************************************************************************
;*                       TABELLE FUER ALLE SEKUNDEN SCHALTEN AUS             *
;*                              25.03.10                                     *
;*****************************************************************************
        ORG 0X0D00
SEC_AUS MOVLW H'0D'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XD00
        MOVWF PCLATH

        MOVF  ZAE,W     ;ZAEHLER IN W
        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 

;HIER STEHEN DIE BCD-ZEITEN DRIN  
    
        RETLW H'01'     ;EIN: 09H 45MIN 00SEC / AUS: 09H 45MIN 01SEC

        RETLW 0XFF      ;ENDEKENNZEICHEN


;*****************************************************************************
;*                       TABELLE FUER WOCHENTAG EINSCHALTEN ZULASSEN         *
;*                              21.04.12                                     *
;*****************************************************************************
;        ORG 0X0E00
;WOCH_EIN MOVLW H'0E'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XE00
;        MOVWF PCLATH

;        MOVF  ZAE,W     ;ZAEHLER IN W
;        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 

;BEISPIELE:
;DIESEN ZEITZYKLUS NUR MONTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00000001'

;DIESEN ZEITZYKLUS NUR DIENSTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00000010'

;DIESEN ZEITZYKLUS NUR MITTWOCH ZULASSEN ZUM SCHALTEN
;RETLW B'00000100'

;DIESEN ZEITZYKLUS NUR DONNERSTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00001000'

;DIESEN ZEITZYKLUS NUR SONNTAG UND MONTAG ZULASSEN ZUM SCHALTEN
;RETLW B'01000001'

;DIESEN ZEITZYKLUS DIE GANZE WOCHEN (JEDEN WOCHENTAG) ZULASSEN ZUM SCHALTEN
;RETLW B'01111111'

;ES GEHT LOS:
 
;        RETLW B'01111111'   ;DIE GANZE WOCHEN

;        RETLW 0XFF      ;ENDEKENNZEICHEN


;*****************************************************************************
;*                       TABELLE FUER WOCHENTAG AUSSCHALTEN ZULASSEN         *
;*                              21.04.12                                     *
;*****************************************************************************
;        ORG 0X0F00
;WOCH_AUS MOVLW H'0F'     ;ADRESSE SPEICHERN NEUES PCLATH ALSO 0XF00
;        MOVWF PCLATH

;        MOVF  ZAE,W     ;ZAEHLER IN W
;        ADDWF PCL,F     ;AUF STELLE DES ZU LESENDEN BYTES BRINGEN 

;BEISPIELE:
;DIESEN ZEITZYKLUS NUR MONTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00000001'

;DIESEN ZEITZYKLUS NUR DIENSTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00000010'

;DIESEN ZEITZYKLUS NUR MITTWOCH ZULASSEN ZUM SCHALTEN
;RETLW B'00000100'

;DIESEN ZEITZYKLUS NUR DONNERSTAG ZULASSEN ZUM SCHALTEN
;RETLW B'00001000'

;DIESEN ZEITZYKLUS NUR SONNTAG UND MONTAG ZULASSEN ZUM SCHALTEN
;RETLW B'01000001'

;DIESEN ZEITZYKLUS DIE GANZE WOCHEN (JEDEN WOCHENTAG) ZULASSEN ZUM SCHALTEN
;RETLW B'01111111'

;ES GEHT LOS:
 
;        RETLW B'01111111'   ;DIE GANZE WOCHEN
                                  
;        RETLW 0XFF      ;ENDEKENNZEICHEN


        END
